/*
 * Copyright (C) 2006  Chris Rose
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package com.aimedia.azjabber;

import java.io.InputStream;
import java.util.Properties;

import org.jivesoftware.smack.GoogleTalkConnection;
import org.jivesoftware.smack.PacketListener;
import org.jivesoftware.smack.XMPPException;
import org.jivesoftware.smack.packet.Packet;

public class JabberTestClient implements PacketListener {

    private static final String AZJABBER_BASE = "aimedia.azjabber.";

    private static final int    TIMEOUT       = 2;

    /**
     * @param args
     */
    public static void main (String[] args) throws Exception {
        Properties props = new Properties ();
        InputStream inStream = JabberTestClient.class.getResourceAsStream ("/jabber.properties");
        props.load (inStream);

        JabberTestClient instance = new JabberTestClient ();
        instance.sendTestMessage (props);
    }

    private void sendTestMessage (Properties props) throws XMPPException {
        String username = props.getProperty (AZJABBER_BASE + "client.username");
        String password = props.getProperty (AZJABBER_BASE + "client.password");
        String resource = props.getProperty (AZJABBER_BASE + "client.resource_name");

        GoogleTalkConnection conn = new GoogleTalkConnection ();
        conn.addPacketListener (this, null);
        conn.addPacketWriterListener (new PacketListener () {

            public void processPacket (Packet packet) {
                System.err.println ("Sent packet: " + packet.toXML ());
            }
        }, null);
        // PacketCollector collector = conn.createPacketCollector (new
        // PacketTypeFilter (Presence.class));
        conn.login (username, password, resource);
        // Bind bind = (Bind) collector.nextResult ();

        // Chat chat = conn.createChat (recipient);

        // Roster roster = conn.getRoster();
        // Iterator iter = roster.getEntries();
        // while (iter.hasNext()) {
        // RosterEntry entry = (RosterEntry) iter.next();
        // System.out.println(entry.getName() + " (" + entry.getUser() + ")");
        // }
        for (int i = 0; i < 10; i++) {
            System.out.println ("Waiting an interval of " + TIMEOUT + " seconds.");
            try {
                Thread.sleep (TIMEOUT * 1000);
            }
            catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace ();
            }
        }
        // while (true) {
        // System.out.println ("Waiting for a presence for " + TIMEOUT + "
        // seconds.");
        // Presence p = (Presence) collector.nextResult (TIMEOUT * 1000);
        //            
        // if (p == null) {
        // System.out.println ("No presence received.");
        // break;
        // }
        //            
        // if (p.getFrom ().startsWith (recipient)) {
        // System.out.println ("Sending message to " + p.getFrom ());
        //                
        // Message msg = new Message (p.getFrom ());
        // msg.setBody ("Testing from a java client");
        // conn.sendPacket (msg);
        //                
        // System.out.println ("Sent. Waiting for 10 seconds");
        // try {
        // Thread.sleep (10000);
        // }
        // catch (InterruptedException e) {
        // // TODO Auto-generated catch block
        // e.printStackTrace();
        // }
        // }
        // }

        conn.close ();
    }

    public void processPacket (Packet packet) {
        System.out.println ("Processing: " + packet.getPacketID () + " (" + packet.getClass ().getName () + ")");
        System.out.println (packet.toXML ());
    }

}
